/* Tabela INSCRMUNICIP: */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes
na tabela REGIAOMUNI */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela REGIAOMUNI
utilizando a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_REGIAOMUNI
AFTER DELETE OR INSERT OR UPDATE
ON REGIAOMUNI FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_CDFILLOGOPER VARCHAR2(4);
  V_DTOPER       DATE;
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDFILLOGOPER := '';

   IF DELETING THEN
      IF :OLD.CDPAIS IS NOT NULL THEN
         V_DESC := V_DESC || 'Cod=' || :OLD.CDPAIS;
      END IF;

      IF :OLD.SGESTADO IS NOT NULL THEN
         V_DESC := V_DESC || ' Est=' || :OLD.SGESTADO;
      END IF;

      IF :OLD.CDMUNICIPIO IS NOT NULL THEN
         V_DESC := V_DESC || ' Municipio=' || :OLD.CDMUNICIPIO;
      END IF;

      IF :OLD.CDREGIAOMUNI IS NOT NULL THEN
         V_DESC := V_DESC || ' Regiao=' || :OLD.CDREGIAOMUNI;
      END IF;

      IF :OLD.NMREGIAOMUNI IS NOT NULL THEN
         V_DESC := V_DESC || ' NumReg=' || :OLD.NMREGIAOMUNI;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDPAIS || :OLD.SGESTADO || :OLD.CDMUNICIPIO || :OLD.CDREGIAOMUNI;
/*      V_CDFILLOGOPER := :OLD.CDFILIAL; */
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDPAIS       <> :NEW.CDPAIS)       OR
            (:OLD.SGESTADO     <> :NEW.SGESTADO)     OR
            (:OLD.CDMUNICIPIO  <> :NEW.CDMUNICIPIO)  OR
            (:OLD.CDREGIAOMUNI <> :NEW.CDREGIAOMUNI) OR
            (:OLD.NMREGIAOMUNI <> :NEW.NMREGIAOMUNI) THEN

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.CDPAIS || :OLD.SGESTADO || :OLD.CDMUNICIPIO || :OLD.CDREGIAOMUNI;
         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDPAIS || :NEW.SGESTADO || :NEW.CDMUNICIPIO || :NEW.CDREGIAOMUNI;
      END IF;

      IF :NEW.CDPAIS IS NOT NULL THEN
         V_DESC := V_DESC || 'Cod=' || :NEW.CDPAIS;
      END IF;

      IF :NEW.SGESTADO IS NOT NULL THEN
         V_DESC := V_DESC || ' Est=' || :NEW.SGESTADO;
      END IF;

      IF :NEW.CDMUNICIPIO IS NOT NULL THEN
         V_DESC := V_DESC || ' Municipio=' || :NEW.CDMUNICIPIO;
      END IF;

      IF :NEW.CDREGIAOMUNI IS NOT NULL THEN
         V_DESC := V_DESC || ' Regiao=' || :NEW.CDREGIAOMUNI;
      END IF;

      IF :NEW.NMREGIAOMUNI IS NOT NULL THEN
         V_DESC := V_DESC || ' NumReg=' || :NEW.NMREGIAOMUNI;
      END IF;

   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                V_DSREMOTEHOST,
                V_DSSERVERRDM,
                V_DSSERVMETHOD,
                V_DSREMOTEOPER);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('REGIAOMUNI',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC, V_CDFILLOGOPER,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST,
                V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('LOG_REGIAOMUNI','4.09.060'); END;
/
