CREATE OR REPLACE TRIGGER LOG_SUP_LOGARQUINTEGRA
AFTER INSERT ON LOGARQUINTEGRA
FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(2000);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF INSERTING THEN
      V_DESC   :=        'Nm arqu.:'          ||''  || NVL(:NEW.NMARQUIVO,'')       ||'  '  ||
                         'Lis. OL:'           ||''  || NVL(:NEW.LISTAOL,'')         ||'  '  ||
                         'Lis. Fil.'          ||''  || NVL(:NEW.LISTAFILIAL,'')     ||'  '  ||
                         'Lis. SubGr.:'       ||''  || NVL(:NEW.LISTASUBGRUPO,'')   ||'  '  ||
                         'Lis. Rota:'         ||''  || NVL(:NEW.LISTATORA,'')       ||'  '  ||
                         'Entr. ini.:'        ||''  || NVL(:NEW.DTPROGENPEOLINI,'') ||'  '  ||
                         'Entr. Fin.:'        ||''  || NVL(:NEW.DTPROGENPEOLFIN,'') ||'  '  ||
                         'Emb. ini.:'         ||''  || NVL(:NEW.DTPROGEMBARQINI,'') ||'  '  ||
                         'Emb. fin.:'         ||''  || NVL(:NEW.DTPROGEMBARQFIN,'') ||'  '  ||
                         'Lis. Lote:'         ||''  || NVL(:NEW.LISTALOTE,'')       ||'  '  ||
                         'Prod ini.:'         ||''  || NVL(:NEW.CDPRODINI,'')       ||'  '  ||
                         'Prod fin:'          ||''  || NVL(:NEW.CDPRODFIN,'');

      V_ITPESQ       := SUBSTR(:NEW.NMARQUIVO, 1, 80);
      V_IDTIPOOPER   := '1';
   END IF;
   IF (V_DESC IS NOT NULL)   THEN
      V_DESC := SUBSTR(V_DESC, 1, 400);
      INSERT INTO LOGOPERA
         (NMTABELA,
          DTOPERACAO,
          NMRESPOPER,
          IDTIPOOPER,
          DSOPERACAO,
          CDPESQITEM,
          DSRDMUSUOPER,
          DSENDUSUOPER,
          DSNMUSUOPER,
          DSMETUSUOPER,
          CDORESPOPER)
      VALUES
         ('LOGARQUINTEGRA',
          SYSDATE,
          NVL(V_NMOPERADOR,' '),
          V_IDTIPOOPER,
          V_DESC,
          V_ITPESQ,
          V_DSSERVERRDM,
          V_DSREMOTEADDR,
          V_DSREMOTEHOST,
          V_DSSERVMETHOD,
          V_DSREMOTEOPER);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_SUP_LOGARQUINTEGRA','5.50.XXX'); END;
/
